"""set property and further class attributes to metamodel classes"""
from constraints import add_type_properties
from interpreter import add_value_properties
from function import add_function_call_properties
from clone import add_deepcopy
from loaders import add_object_loaders


def add_properties(metamodel):
    """set attributes and properties in the metamodel"""
    add_deepcopy(metamodel)
    add_type_properties(metamodel)
    add_value_properties(metamodel)
    add_object_loaders(metamodel)
    add_function_call_properties(metamodel)
