"""
Test type checking and type inference
"""
import sys
from os import path
from textx import metamodel_from_file
from textx.export import metamodel_export, model_export
import metamodel
import constraints

ROOT_DIR = path.dirname(path.abspath(__file__))

metamodel_file = path.join(ROOT_DIR, '../grammar/virtmat.tx')
metamodel_dot_file = path.join(ROOT_DIR, '../grammar/virtmat.dot')
meta = metamodel_from_file(metamodel_file, auto_init_attributes=False)
metamodel.add_properties(meta)
metamodel.add_processors(meta)
constraints.add_processors(meta)
metamodel_export(meta, metamodel_dot_file)

model_file = sys.argv[1]
model_dot_file = path.splitext(model_file)[0]+'.dot'
program = meta.model_from_file(model_file)
model_export(program, model_dot_file)
