"""
Execute a program locally and immediately
"""
import sys
from os import path
from textx import metamodel_from_file
import metamodel
import constraints

ROOT_DIR = path.dirname(path.abspath(__file__))

metamodel_file = path.join(ROOT_DIR, '../grammar/virtmat.tx')
meta = metamodel_from_file(metamodel_file, auto_init_attributes=False)
metamodel.add_properties(meta)
metamodel.add_processors(meta)
constraints.add_processors(meta)

model_file = sys.argv[1]
program = meta.model_from_file(model_file)
if isinstance(program, str):
    if program:
        print(program)
elif program.value:
    print(program.value)
